/**********************************************************************
Copyright (c) 2002 Mike Martin (TJDO) and others. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Contributors:
2002 Kelly Grizzle (TJDO)
2003 Andy Jefferson - commented and localised.
    ...
**********************************************************************/
package org.datanucleus.jdo.exceptions;

import javax.jdo.JDOFatalException;

import org.datanucleus.ObjectManagerFactoryImpl;
import org.datanucleus.util.Localiser;

/**
 * A <tt>CommitStateTransitionException</tt> is thrown when an error occurs
 * transitioning from one state to another
 *
 * @version $Revision: 1.1 $
 */
public class CommitStateTransitionException extends JDOFatalException
{
    private static final Localiser LOCALISER = Localiser.getInstance("org.datanucleus.Localisation",
        ObjectManagerFactoryImpl.class.getClassLoader());

    /**
     * Constructor.
     * @param nested Nested exceptions
     **/
    public CommitStateTransitionException(java.lang.Exception[] nested)
    {
        super(LOCALISER.msg("015037"),nested);
    }
}
