/**********************************************************************
 Copyright (c) 2006 Erik Bengtson and others. All rights reserved.
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 

 Contributors:
 ...
 **********************************************************************/
package org.datanucleus.enhancer.samples;

/**
 * JDO spec 21.16 says: "The generated static initialization code is placed
 * after any user-defined static initialization code"
 */
public class UserStaticBlock
{
    public static final String log = "TEXT";

    public static String F;

    static
    {
        F = "F";
    }

    public UserStaticBlock()
    {
        if (log.equals("TEXT"))
        {
            // the above code should work
        }
        else
        {
            throw new RuntimeException("log variable not initialised");
        }
        if (F.equals("F"))
        {
            // the above code should work
        }
        else
        {
            throw new RuntimeException("F variable not initialised");
        }
    }
}
